/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.filters.SelectCellSets;


import org.apache.log4j.Logger;

import java.util.List;
import org.visnow.vn.engine.core.ParameterProxy;

import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.gui.widgets.RunButton;

import static org.visnow.vn.lib.basic.filters.SelectCellSets.SelectedCellSetsShared.*;

public class GUI extends javax.swing.JPanel
{
    private static final Logger LOGGER = Logger.getLogger(GUI.class);

    protected Parameters parameters;

    public void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }    
    
    /**
     * Creates new form EmptyVisnowModuleGUI
     */
    public GUI()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        cellSetsList = new javax.swing.JList();
        cellLabel = new javax.swing.JLabel();
        dimsLabel = new javax.swing.JLabel();
        runButton = new org.visnow.vn.gui.widgets.RunButton();
        filler = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setMinimumSize(new java.awt.Dimension(180, 270));
        setLayout(new java.awt.GridBagLayout());

        cellSetsList.setBorder(javax.swing.BorderFactory.createTitledBorder("cell sets"));
        cellSetsList.setToolTipText("Select cell sets to output");
        cellSetsList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                cellSetsListValueChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 0.8;
        add(cellSetsList, gridBagConstraints);

        cellLabel.setText(" ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 0, 0);
        add(cellLabel, gridBagConstraints);

        dimsLabel.setMaximumSize(new java.awt.Dimension(160, 20));
        dimsLabel.setMinimumSize(new java.awt.Dimension(85, 18));
        dimsLabel.setOpaque(true);
        dimsLabel.setPreferredSize(new java.awt.Dimension(120, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 0, 0);
        add(dimsLabel, gridBagConstraints);

        runButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener() {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
                runButtonUserChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        add(runButton, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 0.1;
        add(filler, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents
   
    private void cellSetsListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_cellSetsListValueChanged
        if (!evt.getValueIsAdjusting()) {
            List selItems = cellSetsList.getSelectedValuesList();
            String[] selCellSetNames = new String[selItems.size()];
            int i = 0;
            for (Object selItem : selItems) {
                selCellSetNames[i] = (String)selItem;
                i += 1;
            }
            parameters.set(SELECTED_CELL_SETS, selCellSetNames);
        }
        runButton.setPendingIfNoAuto();
    }//GEN-LAST:event_cellSetsListValueChanged

    private void runButtonUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {//GEN-FIRST:event_runButtonUserChangeAction
        parameters.set(RUNNING_MESSAGE, (RunButton.RunState) evt.getEventData());
    }//GEN-LAST:event_runButtonUserChangeAction

      
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JLabel cellLabel;
    private javax.swing.JList cellSetsList;
    private javax.swing.JLabel dimsLabel;
    private javax.swing.Box.Filler filler;
    private org.visnow.vn.gui.widgets.RunButton runButton;
    // End of variables declaration//GEN-END:variables

    void updateGUI(ParameterProxy clonedParameters, boolean resetFully, boolean setRunButtonPending) {
        
        // Different number of components is not considered a different field.
        cellSetsList.setListData(clonedParameters.get(META_CELL_SET_NAMES));
        
        runButton.updateAutoState(clonedParameters.get(RUNNING_MESSAGE));
        runButton.updatePendingState(setRunButtonPending);
    }
}
